datablock fxdtsbrickData(Brick1x1fRoundSpawnData:Brick1x1fRoundData)
{
   category = "Special";
   subCategory = "MISC";
   uiname = "Little People Spawn";
};
if(isPackage(mLittlePeople))
   deactivatepackage(mLittlePeople);
package mLittlePeople
{
   function fxDtsBrickData::onPlant(%data,%obj)
   {
      Parent::onPlant(%data,%obj);
      if(%data == nameToID("Brick1x1fRoundSpawnData") && %obj.getGroup().littlePeople < 5)
         %obj.schedule(0,mLittleSpawn);
      else if (%data == nameToID("Brick1x1fRoundSpawnData") && %obj.getGroup().littlePeople > 4)
         %obj.killbrick();
   }
};
schedule(0,0,activatepackage,mLittlePeople);

function fxDtsBrick::mLittleSpawn(%obj)
{
   %brick = new fxDTSBrick()
   {
      position = vectorAdd(%obj.getPosition(),"0 0 0.2");
      datablock = brick1x1RoundData;
      colorid=%obj.colorid;
      isPlanted=0;
      group = %obj.getGroup();
      spawnbrick=%obj;
   };
   %brick.group.littlePeople++;
   if(!isObject(mLittlePeopleGroup))
      new SimGroup(mLittlePeopleGroup);
   mLittlePeopleGroup.add(%brick);
   %brick.mLittleTick();
}
function fxDtsBrick::mLittleTick(%obj)
{
   cancel(%obj.mLittleSched);
   if(!isObject(%obj.spawnBrick))
   {
      %obj.schedule(0,delete);
      %obj.group.littlePeople--;
      return;
   }
   if(%obj.mLastMoveTime + 1000 < getSimTime())
   {
      %obj.mLastMoveTime = getSimTime();
      %obj.mLittle_tryMove();
   }
   %obj.mLittleSched=%obj.schedule(50,mLittleTick);
}
function fxDtsBrick::mLittle_TryMove(%obj)
{
   %pos=mLittle_Pos();
   while(!%obj.mLittle_Raycast(%pos))
   {
      %i++;
      if(%i>100)
         break;
      %pos=mLittle_Pos();
   }
   %obj.mLittle_getCorrectPos(%pos);
}
function fxDtsBrick::mLittle_GetCorrectPos(%obj,%pos)
{
   %pos = vectorAdd(%obj.getPosition(),%pos);
   %mask = $Typemasks::fxBrickObjectType | $Typemasks::StaticObjectType;
   %ray = containerRaycast(vectorAdd(%pos,"0 0 0.2"),vectorAdd(%pos,"0 0 -0.6"),%mask,%obj);
   %col = firstWord(%ray);
   if(!isObject(%col))
      %obj.setTransform(%pos);
   else
      %obj.setTransform(vectorAdd(posFromRaycast(%ray),"0 0 0.3"));
}
function mLittle_Pos()
{
   %a=getRandom(0,3);
   switch(%a)
   {
      case 0 : return "-0.5 0 0";
      case 1 : return "0.5 0 0";
      case 2 : return "0 -0.5 0";
      case 3 : return "0 0.5 0";
      default : return "-0.5 0 0";
   }
}
function fxDtsBrick::mLittle_Raycast(%obj,%pos)
{
   %cur=%obj.getPosition();
   %new = vectorAdd(%pos,%cur);
   %ray = containerRaycast(%cur,%new,$Typemasks::fxBrickObjectType,%obj);
   %mask = %mask = $Typemasks::fxBrickObjectType | $Typemasks::StaticObjectType;
   %ray2 = containerRaycast(%new,vectorAdd(%new,"0 0 -0.7"),%mask,%obj);
   
   return !isObject(%ray) && isObject(%ray2) ;
}
function servercmdclearLittlePeople(%c)
{
   if(!%c.isAdmin)
      return;
   %count = mLittlePeopleGroup.getCount();
   for(%i=0;%i<%count;%i++)
   {
      %obj = mLittlePeopleGroup.getObject(%i);
      %obj.group.littlePeople--;
      %obj.schedule(0,delete);
   }
   if(%count)
      messageAll('MsgClearBricks',"\c3"@%c.name@"\c6 cleared all Little People ("@%count@")");
}